<template>
    <div class="content-grid content-grid--subpage content-grid--subpage-table">
        <Breadcrumbs :title="t(`routes.admin.children.events.name`)" />
        <div class="content-grid__header">
            <h1 class="back-link-title">{{ t(`routes.admin.children.events.name`) }}</h1>
            <div class="content-grid__filters">
                <SearchInput v-model="searchValue" />
            </div>
        </div>
        <Card :title="t('global.quickLinks')">        
            <BtnLink
                :name="t('routes.admin.children.events.add.name')"
                :path="{ name: 'admin.children.events.add' }" />
        </Card>
        <Card>
            <DataTable :headers="eventHeader"
                       :search-value="searchValue"
                       :is-loading="enChargement"
                       :items="tableEvents"
                       @delete="deleteEvent" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
    import i18n from "@/i18n";
    import { useI18n } from "vue3-i18n";
    import { computed, onMounted, ref } from "vue";
    import { useEventService } from "@/inversify.config";
    import { notifyError, notifySuccess } from "@/notify";
    import Card from "@/components/layout/Card.vue";
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import SearchInput from "@/components/layout/SearchInput.vue";
    import DataTable from "@/components/layout/DataTable.vue";
    import BtnLink from "@/components/layout/BtnLink.vue";
    import { Event } from "@/types/entities";
    import { Guid } from "@/types";
    
    const { t } = useI18n()
    const eventService = useEventService()

    const lesEvents = ref<Event[]>([]);
    const searchValue = ref("");
    const enChargement = ref(false);

    const tableEvents = computed(() => {
        return lesEvents.value.map((x: Event) => {
            return {
                id: x.id,
                month: (x.month) ?? '',
                jour: x.jour ?? '',
                dayOfWeek: x.dayOfWeek ?? '',
                description: x.description ?? "Vide",
                actions: {
                    update: { name: `admin.children.events.edit`, params: { id: x.id } },
                    delete: true
                }
            }
        }) as Event[];
    })

    onMounted(async () => {
        await chargerEvents();
    });

    
    async function chargerEvents() {
        enChargement.value = true;

        let events = await eventService.getAllEvents();
        if (events && events.length > 0) {
            lesEvents.value = events;
        }
        enChargement.value = false;
    }


    async function deleteEvent(event: any) {
        if (event?.id == null || !Guid.isValid(event.id ?? ""))
            return

        let confirmDelete = confirm(t("validation.event.delete.confirmation"));
        if (!confirmDelete)
            return;

        let response = await eventService.deleteEvent(event.id)
        if (response.succeeded) {
            lesEvents.value = lesEvents.value.filter(x => x.id !== event.id)
            notifySuccess(t('validation.event.delete.success'))
        } else {
            let errorMessages = response.getErrorMessages('validation.event.delete',
                'validation.event.delete.errorOccured')
            notifyError(errorMessages[0])
        }
    }

    const eventHeader = [
        {
            text: t("event.month"),
            value: "month",
            sortable: false,
            width: 300,
        },
        {
            text: t("event.jour"),
            value: "jour",
            sortable: false,
            width: 150,
        },
        {
            text: t("event.dayOfWeek"),
            value: "dayOfWeek",
            sortable: false,
            width: 150,
        },
        {
            text: t("event.description"),
            value: "description",
            sortable: false,
            width: 300,
        },
        {
            text: t("global.table.actions"),
            value: "actions",
            width: 75
        }
    ];
</script>
